package seminar13.solid3;

// Porušení Open/Closed principle - použijeme dědičnost

public class Payment {
    public void pay(Method method, Money amount) {
        method.confirmPaymentReceived(amount);
        printReceipt(amount);
        dispatchGoods();
    }
    private void printReceipt(Money amount) { }
    private void dispatchGoods() { }
}

class TransferMethod implements Method {
    @Override
    public void confirmPaymentReceived(Money amount) {
        // transfer
    }
}

class CashMethod implements Method {
    @Override
    public void confirmPaymentReceived(Money amount) {
        // accept cash
    }
}

