package seminar13.solid7;

// Porušen Dependency inversion principle - přenecháme zodpovědnost za vytvoření loggeru na klientovi používajícím třídu Customer

public class Customer
{
    private final ILogger logger;
    
    public Customer(ILogger logger)
    {
        this.logger = logger;
    }
    
    public void add()
    {
        try
        {
            // Database code goes here
        }
        catch (Exception ex)
        {
            logger.handle(ex.toString());
        }
    }
}

class FileLogger implements ILogger
{
    @Override
    public void handle(String error)
    {
        /* ... */
    }
}
